diff --git a/rsvg-image.c b/rsvg-image.c
index 096ed09..8eb03ef 100644
--- a/rsvg-image.c
+++ b/rsvg-image.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-image.c: Image loading and displaying
 
@@ -33,398 +34,86 @@
 #include <math.h>
 #include <errno.h>
 #include "rsvg-css.h"
-#ifdef HAVE_GIO
-#include <gio/gio.h>
-#endif
-
-static const char s_UTF8_B64Alphabet[64] = {
-    0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f,
-    0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x59, 0x5a,   /* A-Z */
-    0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x68, 0x69, 0x6a, 0x6b, 0x6c, 0x6d, 0x6e, 0x6f,
-    0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78, 0x79, 0x7a,   /* a-z */
-    0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, /* 0-9 */
-    0x2b,                       /* + */
-    0x2f                        /* / */
-};
-static const char utf8_b64_pad = 0x3d;
-
-static gboolean
-b64_decode_char (char c, int *b64)
-{
-    if ((c >= 0x41) && (c <= 0x5a)) {
-        *b64 = c - 0x41;
-        return TRUE;
-    }
-    if ((c >= 0x61) && (c <= 0x7a)) {
-        *b64 = c - (0x61 - 26);
-        return TRUE;
-    }
-    if ((c >= 0x30) && (c <= 0x39)) {
-        *b64 = c + (52 - 0x30);
-        return TRUE;
-    }
-    if (c == 0x2b) {
-        *b64 = 62;
-        return TRUE;
-    }
-    if (c == 0x2f) {
-        *b64 = 63;
-        return TRUE;
-    }
-    return FALSE;
-}
+#include "rsvg-io.h"
 
-static gboolean
-utf8_base64_decode (guchar ** binptr, size_t * binlen, const char *b64ptr, size_t b64len)
+cairo_surface_t *
+rsvg_cairo_surface_new_from_href (RsvgHandle *handle,
+                                  const char *href,
+                                  GError **error)
 {
-    gboolean decoded = TRUE;
-    gboolean padding = FALSE;
-
-    int i = 0;
-    glong ucs4_len, j;
-
-    unsigned char byte1 = 0;
-    unsigned char byte2;
-
-    gunichar ucs4, *ucs4_str;
-
-    if (b64len == 0)
-        return TRUE;
-
-    if ((binptr == 0) || (b64ptr == 0))
-        return FALSE;
-
-    ucs4_str = g_utf8_to_ucs4_fast (b64ptr, b64len, &ucs4_len);
-
-    for (j = 0; j < ucs4_len; j++) {
-        ucs4 = ucs4_str[j];
-        if ((ucs4 & 0x7f) == ucs4) {
-            int b64;
-            char c = (char) (ucs4);
-
-            if (b64_decode_char (c, &b64)) {
-                if (padding || (*binlen == 0)) {
-                    decoded = FALSE;
-                    break;
-                }
-
-                switch (i) {
-                case 0:
-                    byte1 = (unsigned char) (b64) << 2;
-                    i++;
-                    break;
-                case 1:
-                    byte2 = (unsigned char) (b64);
-                    byte1 |= byte2 >> 4;
-                    *(*binptr)++ = (char) (byte1);
-                    (*binlen)--;
-                    byte1 = (byte2 & 0x0f) << 4;
-                    i++;
-                    break;
-                case 2:
-                    byte2 = (unsigned char) (b64);
-                    byte1 |= byte2 >> 2;
-                    *(*binptr)++ = (char) (byte1);
-                    (*binlen)--;
-                    byte1 = (byte2 & 0x03) << 6;
-                    i++;
-                    break;
-                default:
-                    byte1 |= (unsigned char) (b64);
-                    *(*binptr)++ = (char) (byte1);
-                    (*binlen)--;
-                    i = 0;
-                    break;
-                }
-
-                if (!decoded)
-                    break;
-
-                continue;
-            } else if (c == utf8_b64_pad) {
-                switch (i) {
-                case 0:
-                case 1:
-                    decoded = FALSE;
-                    break;
-                case 2:
-                    if (*binlen == 0)
-                        decoded = FALSE;
-                    else {
-                        *(*binptr)++ = (char) (byte1);
-                        (*binlen)--;
-                        padding = TRUE;
-                    }
-                    i++;
-                    break;
-                default:
-                    if (!padding) {
-                        if (*binlen == 0)
-                            decoded = FALSE;
-                        else {
-                            *(*binptr)++ = (char) (byte1);
-                            (*binlen)--;
-                            padding = TRUE;
-                        }
-                    }
-                    i = 0;
-                    break;
-                }
-                if (!decoded)
-                    break;
-
-                continue;
-            }
-        }
-        if (g_unichar_isspace (ucs4))
-            continue;
-
-        decoded = FALSE;
-        break;
-    }
-
-    g_free (ucs4_str);
-    return decoded;
-}
-
-static GByteArray *
-rsvg_acquire_base64_resource (const char *data, GError ** error)
-{
-    GByteArray *array;
-
-    guchar *bufptr;
-    size_t buffer_len, buffer_max_len, data_len;
-
-    rsvg_return_val_if_fail (data != NULL, NULL, error);
-
-    while (*data)
-        if (*data++ == ',')
-            break;
-
-    data_len = strlen (data);
-
-    buffer_max_len = ((data_len >> 2) + 1) * 3;
-    buffer_len = buffer_max_len;
-
-    array = g_byte_array_sized_new (buffer_max_len);
-    bufptr = array->data;
-
-    if (!utf8_base64_decode (&bufptr, &buffer_len, data, data_len)) {
-        g_byte_array_free (array, TRUE);
+    char *data;
+    gsize data_len;
+    char *mime_type = NULL;
+    GdkPixbufLoader *loader = NULL;
+    GdkPixbuf *pixbuf = NULL;
+    cairo_surface_t *surface = NULL;
+
+    data = _rsvg_handle_acquire_data (handle, href, &mime_type, &data_len, error);
+    if (data == NULL)
         return NULL;
-    }
-
-    array->len = buffer_max_len - buffer_len;
-
-    return array;
-}
 
-gchar *
-rsvg_get_file_path (const gchar * filename, const gchar * base_uri)
-{
-    gchar *absolute_filename;
-
-    if (g_file_test (filename, G_FILE_TEST_EXISTS) || g_path_is_absolute (filename)) {
-        absolute_filename = g_strdup (filename);
+    if (mime_type) {
+        loader = gdk_pixbuf_loader_new_with_mime_type (mime_type, error);
     } else {
-        gchar *tmpcdir;
-	gchar *base_filename;
-
-        if (base_uri) {
-	    base_filename = g_filename_from_uri (base_uri, NULL, NULL);
-	    if (base_filename != NULL) {
-		tmpcdir = g_path_get_dirname (base_filename);
-		g_free (base_filename);
-	    } else 
-		return NULL;
-	} else
-	    tmpcdir = g_get_current_dir ();
-
-        absolute_filename = g_build_filename (tmpcdir, filename, NULL);
-        g_free (tmpcdir);
+        loader = gdk_pixbuf_loader_new ();
     }
 
-    return absolute_filename;
-}
-
-static GByteArray *
-rsvg_acquire_file_resource (const char *filename, const char *base_uri, GError ** error)
-{
-    GByteArray *array;
-    gchar *path;
-
-    guchar buffer[4096];
-    int length;
-    FILE *f;
+    if (loader == NULL)
+        goto out;
 
-    rsvg_return_val_if_fail (filename != NULL, NULL, error);
+    if (!gdk_pixbuf_loader_write (loader, (guchar *) data, data_len, error)) {
+        gdk_pixbuf_loader_close (loader, NULL);
+        goto out;
+    }
 
-    path = rsvg_get_file_path (filename, base_uri);
-    if (path == NULL)
-	return NULL;
+    if (!gdk_pixbuf_loader_close (loader, error))
+        goto out;
 
-    f = fopen (path, "rb");
-    g_free (path);
+    pixbuf = gdk_pixbuf_loader_get_pixbuf (loader);
 
-    if (!f) {
+    if (!pixbuf) {
         g_set_error (error,
-                     G_FILE_ERROR,
-                     g_file_error_from_errno (errno),
-                     _("Failed to open file '%s': %s"), filename, g_strerror (errno));
-        return NULL;
+                     GDK_PIXBUF_ERROR,
+                     GDK_PIXBUF_ERROR_FAILED,
+                      _("Failed to load image '%s': reason not known, probably a corrupt image file"),
+                      href);
+        goto out;
     }
 
-    /* TODO: an optimization is to use the file's size */
-    array = g_byte_array_new ();
+    surface = rsvg_cairo_surface_from_pixbuf (pixbuf);
 
-    while (!feof (f)) {
-        length = fread (buffer, 1, sizeof (buffer), f);
-        if (length > 0) {
-            if (g_byte_array_append (array, buffer, length) == NULL) {
-                fclose (f);
-                g_byte_array_free (array, TRUE);
-                return NULL;
-            }
-        } else if (ferror (f)) {
-            fclose (f);
-            g_byte_array_free (array, TRUE);
-            return NULL;
-        }
-    }
-
-    fclose (f);
+    if (mime_type == NULL) {
+        /* Try to get the information from the loader */
+        GdkPixbufFormat *format;
+        char **mime_types;
 
-    return array;
-}
+        if ((format = gdk_pixbuf_loader_get_format (loader)) != NULL) {
+            mime_types = gdk_pixbuf_format_get_mime_types (format);
 
-#ifdef HAVE_GIO
-
-static void
-rsvg_free_error (GError ** err)
-{
-	if (err) {
-		if (*err) {
-			g_error_free (*err);
-			*err = NULL;
-		}
-	}
-}
-
-static GByteArray *
-rsvg_acquire_vfs_resource (const char *filename, const char *base_uri, GError ** error)
-{
-    GByteArray *array;
-
-    GFile *file;
-    char *data;
-    gsize size;
-    gboolean res = FALSE;
-
-    rsvg_return_val_if_fail (filename != NULL, NULL, error);
-
-    file = g_file_new_for_uri (filename);
-
-    if (!(res = g_file_load_contents (file, NULL, &data, &size, NULL, error))) {
-        if (base_uri != NULL) {
-            GFile *base;
-
-			rsvg_free_error(error);
-			
-			g_object_unref (file);
-
-            base = g_file_new_for_uri (base_uri);
-            file = g_file_resolve_relative_path (base, filename);
-            g_object_unref (base);
-
-			res = g_file_load_contents (file, NULL, &data, &size, NULL, error);
+            if (mime_types != NULL)
+                mime_type = g_strdup (mime_types[0]);
+            g_strfreev (mime_types);
         }
     }
-
-	g_object_unref (file);
-
-    if (res) {
-        array = g_byte_array_new ();
-
-        g_byte_array_append (array, (guint8 *)data, size);
-        g_free (data);
-    } else {
-        return NULL;
+#if 0
+    /* Don't handle this at all.  Older versions of Cairo don't provide
+     * cairo_surface_set_mime_data() anyway.
+     */
+    if ((handle->priv->flags & RSVG_HANDLE_FLAG_KEEP_IMAGE_DATA) != 0 &&
+        mime_type != NULL &&
+        cairo_surface_set_mime_data (surface, mime_type, (guchar *) data,
+                                     data_len, g_free, data) == CAIRO_STATUS_SUCCESS) {
+        data = NULL; /* transferred to the surface */
     }
-
-    return array;
-}
-#endif
-
-GByteArray *
-_rsvg_acquire_xlink_href_resource (const char *href, const char *base_uri, GError ** err)
-{
-    GByteArray *arr = NULL;
-
-    if (!(href && *href))
-        return NULL;
-
-    if (!strncmp (href, "data:", 5))
-        arr = rsvg_acquire_base64_resource (href, NULL);
-
-    if (!arr)
-        arr = rsvg_acquire_file_resource (href, base_uri, NULL);
-
-#ifdef HAVE_GIO
-    if (!arr)
-        arr = rsvg_acquire_vfs_resource (href, base_uri, NULL);
 #endif
 
-    return arr;
-}
-
-GdkPixbuf *
-rsvg_pixbuf_new_from_href (const char *href, const char *base_uri, GError ** error)
-{
-    GByteArray *arr;
-
-    arr = _rsvg_acquire_xlink_href_resource (href, base_uri, error);
-    if (arr) {
-        GdkPixbufLoader *loader;
-        GdkPixbuf *pixbuf = NULL;
-        int res;
-
-        loader = gdk_pixbuf_loader_new ();
-
-        res = gdk_pixbuf_loader_write (loader, arr->data, arr->len, error);
-        g_byte_array_free (arr, TRUE);
-
-        if (!res) {
-            gdk_pixbuf_loader_close (loader, NULL);
-            g_object_unref (loader);
-            return NULL;
-        }
-
-        if (!gdk_pixbuf_loader_close (loader, error)) {
-            g_object_unref (loader);
-            return NULL;
-        }
-
-        pixbuf = gdk_pixbuf_loader_get_pixbuf (loader);
-
-        if (!pixbuf) {
-            g_object_unref (loader);
-            g_set_error (error,
-                         GDK_PIXBUF_ERROR,
-                         GDK_PIXBUF_ERROR_FAILED,
-                         _
-                         ("Failed to load image '%s': reason not known, probably a corrupt image file"),
-                         href);
-            return NULL;
-        }
-
-        g_object_ref (pixbuf);
-
+  out:
+    if (loader)
         g_object_unref (loader);
+    g_free (mime_type);
+    g_free (data);
 
-        return pixbuf;
-    }
-
-    return NULL;
+    return surface;
 }
 
 void
@@ -473,8 +162,8 @@ rsvg_node_image_free (RsvgNode * self)
     rsvg_state_finalize (z->super.state);
     g_free (z->super.state);
     z->super.state = NULL;
-    if (z->img)
-        g_object_unref (G_OBJECT (z->img));
+    if (z->surface)
+        cairo_surface_destroy (z->surface);
     _rsvg_node_free(self);
 }
 
@@ -483,10 +172,10 @@ rsvg_node_image_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
 {
     RsvgNodeImage *z = (RsvgNodeImage *) self;
     unsigned int aspect_ratio = z->preserve_aspect_ratio;
-    GdkPixbuf *img = z->img;
     gdouble x, y, w, h;
+    cairo_surface_t *surface = z->surface;
 
-    if (img == NULL)
+    if (surface == NULL)
         return;
 
     x = _rsvg_css_normalize_length (&z->x, ctx, 'h');
@@ -498,14 +187,16 @@ rsvg_node_image_draw (RsvgNode * self, RsvgDrawingCtx * ctx, int dominate)
 
     rsvg_push_discrete_layer (ctx);
 
-    if (!rsvg_state_current (ctx)->overflow && (aspect_ratio & RSVG_ASPECT_RATIO_SLICE)) {
+    if (!rsvg_current_state (ctx)->overflow && (aspect_ratio & RSVG_ASPECT_RATIO_SLICE)) {
         rsvg_add_clipping_rect (ctx, x, y, w, h);
     }
 
-    rsvg_preserve_aspect_ratio (aspect_ratio, (double) gdk_pixbuf_get_width (img),
-                                (double) gdk_pixbuf_get_height (img), &w, &h, &x, &y);
+    rsvg_preserve_aspect_ratio (aspect_ratio, 
+                                (double) cairo_image_surface_get_width (surface),
+                                (double) cairo_image_surface_get_height (surface), 
+                                &w, &h, &x, &y);
 
-    rsvg_render_image (ctx, img, x, y, w, h);
+    rsvg_render_surface (ctx, surface, x, y, w, h);
 
     rsvg_pop_discrete_layer (ctx);
 }
@@ -528,11 +219,13 @@ rsvg_node_image_set_atts (RsvgNode * self, RsvgHandle * ctx, RsvgPropertyBag * a
         /* path is used by some older adobe illustrator versions */
         if ((value = rsvg_property_bag_lookup (atts, "path"))
             || (value = rsvg_property_bag_lookup (atts, "xlink:href"))) {
-            image->img = rsvg_pixbuf_new_from_href (value, rsvg_handle_get_base_uri (ctx), NULL);
+            image->surface = rsvg_cairo_surface_new_from_href (ctx,
+                                                               value, 
+                                                               NULL);
 
-            if (!image->img) {
+            if (!image->surface) {
 #ifdef G_ENABLE_DEBUG
-                g_warning (_("Couldn't load image: %s\n"), value);
+                g_warning ("Couldn't load image: %s\n", value);
 #endif
             }
         }
@@ -554,9 +247,9 @@ rsvg_new_image (void)
 {
     RsvgNodeImage *image;
     image = g_new (RsvgNodeImage, 1);
-    _rsvg_node_init (&image->super);
+    _rsvg_node_init (&image->super, RSVG_NODE_TYPE_IMAGE);
     g_assert (image->super.state);
-    image->img = NULL;
+    image->surface = NULL;
     image->preserve_aspect_ratio = RSVG_ASPECT_RATIO_XMID_YMID;
     image->x = image->y = image->w = image->h = _rsvg_css_parse_length ("0");
     image->super.free = rsvg_node_image_free;
diff --git a/rsvg-image.h b/rsvg-image.h
index 273d2c7..9f291d0 100644
--- a/rsvg-image.h
+++ b/rsvg-image.h
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-image.h: Image loading and displaying
 
@@ -31,8 +32,11 @@
 
 #include "rsvg-structure.h"
 
+#include <cairo.h>
+
 G_BEGIN_DECLS 
 
+G_GNUC_INTERNAL
 RsvgNode *rsvg_new_image (void);
 
 typedef struct _RsvgNodeImage RsvgNodeImage;
@@ -41,16 +45,14 @@ struct _RsvgNodeImage {
     RsvgNode super;
     gint preserve_aspect_ratio;
     RsvgLength x, y, w, h;
-    GdkPixbuf *img;
+    cairo_surface_t *surface; /* a cairo image surface */
 };
 
+G_GNUC_INTERNAL
 void rsvg_preserve_aspect_ratio (unsigned int aspect_ratio, double width,
                                  double height, double *w, double *h, double *x, double *y);
-
-
-gchar *rsvg_get_file_path (const gchar * filename, const gchar * basedir);
-
-GdkPixbuf *rsvg_pixbuf_new_from_href (const char *href, const char *base_uri, GError ** error);
+G_GNUC_INTERNAL
+cairo_surface_t *rsvg_cairo_surface_new_from_href (RsvgHandle *handle, const char *href, GError ** error);
 
 G_END_DECLS
 
diff --git a/rsvg-io.c b/rsvg-io.c
new file mode 100644
index 0000000..7452b73
--- /dev/null
+++ b/rsvg-io.c
@@ -0,0 +1,358 @@
+/*
+   Copyright (C) 2000 Eazel, Inc.
+   Copyright (C) 2002, 2003, 2004, 2005 Dom Lachowicz <cinamod@hotmail.com>
+   Copyright (C) 2003, 2004, 2005 Caleb Moore <c.moore@student.unsw.edu.au>
+   Copyright © 2011, 2012 Christian Persch
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+
+   You should have received a copy of the GNU Library General Public
+   License along with this program; if not, write to the
+   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA 02111-1307, USA.
+*/
+
+#include "config.h"
+
+#include "rsvg-io.h"
+#include "rsvg-private.h"
+
+#include <string.h>
+
+/* Copied from soup-request-data.c (LGPL2+):
+ * Copyright (C) 2009, 2010 Red Hat, Inc.
+ * Copyright (C) 2010 Igalia, S.L.
+ * and from soup-uri.c:
+ * Copyright 1999-2003 Ximian, Inc.
+ */
+
+#define XDIGIT(c) ((c) <= '9' ? (c) - '0' : ((c) & 0x4F) - 'A' + 10)
+#define HEXCHAR(s) ((XDIGIT (s[1]) << 4) + XDIGIT (s[2]))
+
+static char *
+uri_decoded_copy (const char *part, 
+                  gsize length)
+{
+    unsigned char *s, *d;
+    char *decoded = g_strndup (part, length);
+
+    s = d = (unsigned char *)decoded;
+    do {
+        if (*s == '%') {
+            if (!g_ascii_isxdigit (s[1]) ||
+                !g_ascii_isxdigit (s[2])) {
+                *d++ = *s;
+                continue;
+            }
+            *d++ = HEXCHAR (s);
+            s += 2;
+        } else {
+            *d++ = *s;
+        }
+    } while (*s++);
+
+    return decoded;
+}
+
+#define BASE64_INDICATOR     ";base64"
+#define BASE64_INDICATOR_LEN (sizeof (";base64") - 1)
+
+static char *
+rsvg_acquire_data_data (const char *uri,
+                        const char *base_uri, 
+                        char **out_mime_type,
+                        gsize *out_len,
+                        GError **error)
+{
+    const char *comma, *start, *end;
+    char *mime_type;
+    char *data;
+    gsize data_len;
+    gboolean base64 = FALSE;
+
+    g_assert (out_len != NULL);
+    g_assert (strncmp (uri, "data:", 5) == 0);
+
+    mime_type = NULL;
+    start = uri + 5;
+    comma = strchr (start, ',');
+
+    if (comma && comma != start) {
+        /* Deal with MIME type / params */
+        if (comma > start + BASE64_INDICATOR_LEN && 
+            !g_ascii_strncasecmp (comma - BASE64_INDICATOR_LEN, BASE64_INDICATOR, BASE64_INDICATOR_LEN)) {
+            end = comma - BASE64_INDICATOR_LEN;
+            base64 = TRUE;
+        } else {
+            end = comma;
+        }
+
+        if (end != start) {
+            mime_type = uri_decoded_copy (start, end - start);
+        }
+    }
+
+    if (comma)
+        start = comma + 1;
+
+    if (*start) {
+	data = uri_decoded_copy (start, strlen (start));
+
+        if (base64)
+            data = (char *) g_base64_decode_inplace (data, &data_len);
+        else
+            data_len = strlen (data);
+    } else {
+        data = NULL;
+        data_len = 0;
+    }
+
+    if (out_mime_type)
+        *out_mime_type = mime_type;
+    else
+        g_free (mime_type);
+
+    *out_len = data_len;
+    return data;
+}
+
+gchar *
+_rsvg_io_get_file_path (const gchar * filename,
+                        const gchar * base_uri)
+{
+    gchar *absolute_filename;
+
+    if (g_file_test (filename, G_FILE_TEST_EXISTS) || g_path_is_absolute (filename)) {
+        absolute_filename = g_strdup (filename);
+    } else {
+        gchar *tmpcdir;
+        gchar *base_filename;
+
+        if (base_uri) {
+            base_filename = g_filename_from_uri (base_uri, NULL, NULL);
+            if (base_filename != NULL) {
+                tmpcdir = g_path_get_dirname (base_filename);
+                g_free (base_filename);
+            } else 
+                return NULL;
+        } else
+            tmpcdir = g_get_current_dir ();
+
+        absolute_filename = g_build_filename (tmpcdir, filename, NULL);
+        g_free (tmpcdir);
+    }
+
+    return absolute_filename;
+}
+
+static char *
+rsvg_acquire_file_data (const char *filename,
+                        const char *base_uri,
+                        char **out_mime_type,
+                        gsize *out_len,
+                        GCancellable *cancellable,
+                        GError **error)
+{
+    gchar *path, *data;
+    gsize len;
+    char *content_type;
+
+    rsvg_return_val_if_fail (filename != NULL, NULL, error);
+    g_assert (out_len != NULL);
+
+    path = _rsvg_io_get_file_path (filename, base_uri);
+    if (path == NULL)
+        return NULL;
+
+    if (!g_file_get_contents (path, &data, &len, error)) {
+        g_free (path);
+        return NULL;
+    }
+
+    if (out_mime_type &&
+        (content_type = g_content_type_guess (path, (guchar *) data, len, NULL))) {
+        *out_mime_type = g_content_type_get_mime_type (content_type);
+        g_free (content_type);
+    }
+
+    g_free (path);
+
+    *out_len = len;
+    return data;
+}
+
+static GInputStream *
+rsvg_acquire_gvfs_stream (const char *uri, 
+                          const char *base_uri, 
+                          char **out_mime_type,
+                          GCancellable *cancellable,
+                          GError **error)
+{
+    GFile *base, *file;
+    GFileInputStream *stream;
+    GError *err = NULL;
+
+    file = g_file_new_for_uri (uri);
+
+    stream = g_file_read (file, cancellable, &err);
+    g_object_unref (file);
+
+    if (stream == NULL &&
+        g_error_matches (err, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
+        g_clear_error (&err);
+
+        base = g_file_new_for_uri (base_uri);
+        file = g_file_resolve_relative_path (base, uri);
+        g_object_unref (base);
+
+        stream = g_file_read (file, cancellable, &err);
+        g_object_unref (file);
+    }
+
+    if (stream == NULL) {
+        g_propagate_error (error, err);
+        return NULL;
+    }
+
+    if (out_mime_type) {
+        GFileInfo *file_info;
+        const char *content_type;
+
+        file_info = g_file_input_stream_query_info (stream, 
+                                                    G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE,
+                                                    cancellable,
+                                                    NULL /* error */);
+        if (file_info &&
+            (content_type = g_file_info_get_content_type (file_info)))
+            *out_mime_type = g_content_type_get_mime_type (content_type);
+        else
+            *out_mime_type = NULL;
+
+        if (file_info)
+            g_object_unref (file_info);
+    }
+
+    return G_INPUT_STREAM (stream);
+}
+
+static char *
+rsvg_acquire_gvfs_data (const char *uri,
+                        const char *base_uri,
+                        char **out_mime_type,
+                        gsize *out_len,
+                        GCancellable *cancellable,
+                        GError **error)
+{
+    GFile *base, *file;
+    GError *err;
+    char *data;
+    gsize len;
+    char *content_type;
+    gboolean res;
+
+    file = g_file_new_for_uri (uri);
+
+    err = NULL;
+    data = NULL;
+    if (!(res = g_file_load_contents (file, cancellable, &data, &len, NULL, &err)) &&
+        g_error_matches (err, G_IO_ERROR, G_IO_ERROR_NOT_FOUND) &&
+        base_uri != NULL) {
+        g_clear_error (&err);
+        g_object_unref (file);
+
+        base = g_file_new_for_uri (base_uri);
+        file = g_file_resolve_relative_path (base, uri);
+        g_object_unref (base);
+
+        res = g_file_load_contents (file, cancellable, &data, &len, NULL, &err);
+    }
+
+    g_object_unref (file);
+
+    if (err) {
+        g_propagate_error (error, err);
+        return NULL;
+    }
+
+    if (out_mime_type &&
+        (content_type = g_content_type_guess (uri, (guchar *) data, len, NULL))) {
+        *out_mime_type = g_content_type_get_mime_type (content_type);
+        g_free (content_type);
+    }
+
+    *out_len = len;
+    return data;
+}
+
+char *
+_rsvg_io_acquire_data (const char *href, 
+                       const char *base_uri, 
+                       char **mime_type,
+                       gsize *len,
+                       GCancellable *cancellable,
+                       GError **error)
+{
+    char *data;
+    gsize llen;
+
+    if (!(href && *href)) {
+        g_set_error_literal (error, G_IO_ERROR, G_IO_ERROR_FAILED,
+                            "Invalid URI");
+        return NULL;
+    }
+
+    if (!len)
+        len = &llen;
+
+    if (strncmp (href, "data:", 5) == 0)
+      return rsvg_acquire_data_data (href, NULL, mime_type, len, error);
+
+    if ((data = rsvg_acquire_file_data (href, base_uri, mime_type, len, cancellable, NULL)))
+      return data;
+
+    if ((data = rsvg_acquire_gvfs_data (href, base_uri, mime_type, len, cancellable, error)))
+      return data;
+
+    return NULL;
+}
+
+GInputStream *
+_rsvg_io_acquire_stream (const char *href, 
+                         const char *base_uri, 
+                         char **mime_type,
+                         GCancellable *cancellable,
+                         GError **error)
+{
+    GInputStream *stream;
+    char *data;
+    gsize len;
+
+    if (!(href && *href)) {
+        g_set_error_literal (error, G_IO_ERROR, G_IO_ERROR_FAILED,
+                            "Invalid URI");
+        return NULL;
+    }
+
+    if (strncmp (href, "data:", 5) == 0) {
+        if (!(data = rsvg_acquire_data_data (href, NULL, mime_type, &len, error)))
+            return NULL;
+
+        return g_memory_input_stream_new_from_data (data, len, (GDestroyNotify) g_free);
+    }
+
+    if ((data = rsvg_acquire_file_data (href, base_uri, mime_type, &len, cancellable, NULL)))
+      return g_memory_input_stream_new_from_data (data, len, (GDestroyNotify) g_free);
+
+    if ((stream = rsvg_acquire_gvfs_stream (href, base_uri, mime_type, cancellable, error)))
+      return stream;
+
+    return NULL;
+}
diff --git a/rsvg-io.h b/rsvg-io.h
new file mode 100644
index 0000000..d710ccf
--- /dev/null
+++ b/rsvg-io.h
@@ -0,0 +1,46 @@
+/*
+   Copyright (C) 2000 Eazel, Inc.
+   Copyright (C) 2002, 2003, 2004, 2005 Dom Lachowicz <cinamod@hotmail.com>
+   Copyright (C) 2003, 2004, 2005 Caleb Moore <c.moore@student.unsw.edu.au>
+   Copyright © 2011, 2012 Christian Persch
+
+   This program is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+
+   You should have received a copy of the GNU Library General Public
+   License along with this program; if not, write to the
+   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA 02111-1307, USA.
+*/
+
+#ifndef RSVG_IO_H
+#define RSVG_IO_H
+
+#include <glib.h>
+#include <gio/gio.h>
+
+G_GNUC_INTERNAL
+gchar *_rsvg_io_get_file_path (const gchar *filename, 
+                               const gchar *basedir);
+
+char *_rsvg_io_acquire_data (const char *uri,
+			     const char *base_uri,
+			     char **mime_type,
+			     gsize *len,
+			     GCancellable *cancellable,
+			     GError **error);
+
+GInputStream *_rsvg_io_acquire_stream (const char *uri,
+                                       const char *base_uri,
+                                       char **mime_type,
+                                       GCancellable *cancellable,
+                                       GError **error);
+
+#endif /* RSVG_IO_H */
